# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

### Added (for new features, dependecies etc.)

### Changed (for changes in existing functionality)

### Deprecated (for soon-to-be removed features) 

### Removed (for now removed features)

### Security (in case of vulnerabilities)

## v0.2-rc.1 (2020-04-10)

### Added (for new features, dependecies etc.)

* ext_bottom_line module (v0.1 - Experimental)
    * A module which adds a preview section where any kind of summarizing
      information (like plots, video players, thumbnails...) can be shown.
    * Enable with build property `BUILD_MODULE_EXT_BOTTOM_LINE=ENABLED`.
    * More documentation in `src/core/js/ext_bottom_line.js`.
* ext_revisions (v0.1 - EXPERIMENTAL)
    * Creates a backup copy of each entity which is updated via the edit_mode.
    * Enable via the build property `BUILD_MODULE_EXT_REVISIONS=ENABLED`.
    * Needs two special entities. A RecordType "Obsolete" and a reference
      property "revisionOf" with data type "Obsolete".
* Map (v0.3)
    * Adds a button to the navbar which toggles a map in the top of the main
      panel. The map currently shows all known entities which have geolocation
      properties and highlights those which are on the current page. Users can
      select an area in the map and generate a query filter for this area which
      is can be openend in the query panel.
    * See the caosdb_map module in  [ext_map.js](./src/core/js/ext_map.js)
    * The default configuration is located in the module itself.
    * The module needs an additional [ext_map.json](./conf/ext/json/ext_map.json)
      which defines at least the tiling server. The tiling server is not
      configured in the default config because this would require the caosdb
      maintainers to enforce the respective usage policies of the tiling server
      providers.
    * Test data for your server can be generated with
      [map_test_data.py](./misc/map_test_data.py).
    * The map module supports different map projections, e.g. Spherical
      Mercartor and projections for the polar regions. The active projection
      can changed by the user with a button.
* navbar module (v0.1)
    * A collection of helper functions for adding stuff to the navbar.
* caosdb_utils module (v0.1)
    * A collection of helper functions for multiple purposes, especially for
      checking a functions parameters (to mimic type savety).
* New Dependency: leaflet-1.5-1
    * for the map
* New Dependency: loglevel-1.6.4
    * Our new logging framework. Any new logging should be done with this
      framework.
* File Upload (v0.1 - EXPERIMENTAL)
    Works only for non-LIST properties
* Edit Mode - switch the LISTishness of entity properties back and forth.

### Changed (for changes in existing functionality)

* The old `caosdb-property-row` CSS class has been replaced by
  `caosdb-v-property-row` for styling and `caosdb-f-property` for functional
  needs.
* The old `caosdb-property-value` and `caosdb-property-edit-value` CSS classes
  have been merged into a new `caosdb-f-property-value` class.
* In [ext_xls_download.js](./src/core/js/ext_xls_download.js): Complete rewrite
  of the module. The generation of the TSV table is done in this module now,
  instead of generating it with xsl (in [query.xsl](./src/core/xsl/query.xsl)).
  Also it is generated on demand.
* In [ext_references.js](./src/core/js/ext_references.js): Updated
  ext_references to v0.2. The new version can also generate and show summaries
  of `LIST` properties.
* In [entity.xsl](./src/core/xsl/entity.xsl): an emtpy property value (a `NULL`
  property) did not produce any `<span>` element with class
  `caosdb-property-text-value`. This caused the current implementation of
  `getPropertyFromElement` in [caosdb.js](./src/core/js/caosdb.js) to return
  the unit of the property as the value. The new implementation produces an
  empty `<span>` (no child text node) which is more appropriate and also fixes
  the buggy `getPropertyFromElement` without touching it.
* In [webcaosdb.js](./src/core/js/webcaosdb.js), `markdown` module: The
  markdown module is very generell and small now. The logic for converting
  comments (aka CommentAnnotations) to markdown is implemented in the
  `annotation` module now (which uses the `markdown` module as back-end, tho).
* updated QUnit test framework to 2.9.2


### Deprecated (for soon-to-be removed features) 

* Image Preview in the FileSystem. The functionality is to be replaced by real
  thumbnails, which cover also non-image data-formats. The thumbnails resource
  is part of the new file system API of the CaosDB Server which is currently
  under development.

### Removed (for now removed features) 

* Removed non-informative tests for webcaosdb.css
* Hard-coded image and video preview in the entity panel. The preview of images
  and videos is controlled by the `ext_bottom_line` module now.

### Fixed (for any bug fixes) 

* #95 - Edit Mode removes property values of reference properties when server
  response for possible reference targets is empty.
* Bug in `getPropertyFromElement` (see above) which returned the unit as the
  property value if the actual value was an empty string.

### Security (in case of vulnerabilities)

