#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
(C) Copyright IndiScale GmbH 2019
"""

import caosdb
import random

caosdb.execute_query("FIND Referenc*").delete()

# data model
datamodel = caosdb.Container()
datamodel.extend([
    caosdb.RecordType("Referenced"),
    caosdb.RecordType(
        "Referencing"
        ).add_property("Referenced", datatype=caosdb.LIST("Referenced")),
])

datamodel.insert()


# test data
testdata = caosdb.Container()

for i in range(100):
    testdata.append(
        caosdb.Record("ReferenceObject-{}".format(i)
            ).add_parent("Referenced")
    )

testdata.insert();
caosdb.Record().add_parent(
    "Referencing"
    ).add_property("Referenced",
                   datatype=caosdb.LIST("Referenced"),
                   value=testdata
    ).insert()

