#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Copyright 2020 IndiScale GmbH <info@indiscale.com>
Copyright 2020 Timm Fitschen <t.fitschen@indiscale.com>
"""

import caosdb
import random
import os

# data model
c = caosdb.execute_query("FIND Test*")
if len(c) > 0:
    print(c)
    delete = input("Delete these entities?\nType `yes`:")
    if delete == "yes":
        c.delete();
    else:
        print("You typed `{}`".format(delete))
        print("[Canceled]")
        exit(0)


print("inserting test data")

upload_file = open("test.dat", "w")
upload_file.write("hello world\n")
upload_file.close()

testdata = caosdb.Container()
testdata.extend([
    caosdb.File("TestFile",
        path="test.dat",
        file="test.dat"),
    caosdb.Property("TestRevisionOf", datatype="TestObsolete"),
    caosdb.RecordType("TestObsolete"),
    caosdb.RecordType("TestRecordType"),
    caosdb.Property("TestProperty", datatype=caosdb.TEXT),
    caosdb.Record("TestRecord"
                 ).add_parent("TestRecordType"
                 ).add_property("TestProperty", "this is a test"),
])

testdata.insert()
os.remove("test.dat")
