/*
 * ** header v3.0
 * This file is a part of the CaosDB Project.
 *
 * Copyright (C) 2019 IndiScale GmbH (info@indiscale.com)
 * Copyright (C) 2019 Daniel Hornung (d.hornung@indiscale.com)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * ** end header
 */
'use strict';

/**
 * Call initially.
 * 
 * TODO refactor to async function for better readability.
 * @return
 */
function footer_initOnDocumentReady() {

    var xhr = new XMLHttpRequest()

    // TODO Refactor and use transformation.retrieveXsltScript, 
    //
    // Event better use the transformation module for injecting an entry point,
    // because this implementation does not allow for non-HTML content in the
    // caosdb-footer template.
    xhr.open("GET", "/webinterface/${BUILD_NUMBER}/xsl/footer.xsl");
    xhr.addEventListener('load', function() {
        if (this.status != 200) {
            // TODO use proper logging framework (log.getLogger("footer.js");)
            console.log(this.status);
            return;
        }
        var footer_xsl = this.responseXML;

        var foot_content = $('[name = "caosdb-footer"]', footer_xsl)[0];
        var fragment = document.createRange().createContextualFragment(
            foot_content.innerHTML);
        var footer = $("footer")[0];
        footer.appendChild(fragment);

    });
    xhr.send();

}

$(document).ready(footer_initOnDocumentReady);
